Bug 2005142 - glibc: pthread_kill should keep return ESRCH for old binaries
Summary: glibc: pthread_kill should keep return ESRCH for old binaries
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: glibc
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Carlos O'Donell
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-09-16 22:05 UTC by Mikhail
Modified: 2021-09-23 18:46 UTC (History)
11 users (show)

Fixed In Version: glibc-2.34.9000-10.fc36
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-09-23 18:46:39 UTC
Type: Bug


Attachments (Terms of Use)
screen of Steam infinitely launching (567.64 KB, image/png)
2021-09-16 22:05 UTC, Mikhail
no flags Details
steam backtrace (214.36 KB, text/plain)
2021-09-17 06:58 UTC, Mikhail
no flags Details
yet another steam backtrace (38.71 KB, text/plain)
2021-09-17 07:34 UTC, Mikhail
no flags Details
Test patch used for glibc-2.34.9000-8.fc36.bz2005142.0 (1.19 KB, text/plain)
2021-09-17 11:08 UTC, Florian Weimer
no flags Details


Links
System ID Private Priority Status Summary Last Updated
Sourceware 19193 0 P2 RESOLVED pthread_kill, pthread_cancel return ESRCH for a thread ID whose lifetime has not ended 2021-09-17 11:51:38 UTC

Description Mikhail 2021-09-16 22:05:12 UTC
Created attachment 1823677 [details]
screen of Steam infinitely launching

Description of problem:
After upgrade glibc from 2.34.9000-6.fc36 to 2.34.9000-8.fc36 version steam client stop working (instead steam infinitely launching)

Last good version glibc 2.34.9000-6.fc36
https://src.fedoraproject.org/rpms/glibc/c/891183e565daa6ae87388e2c6dbb25225216e28d?branch=rawhide
First bad version glibc 2.34.9000-8.fc36
https://src.fedoraproject.org/rpms/glibc/c/7d28ddf24cec1be239b3f6dcf6cd1f281ff0be48?branch=rawhide

Comment 1 Florian Weimer 2021-09-17 02:59:00 UTC
Could you test glibc-2.34.9000-7.fc36 and glibc-2.34-5.fc35 as well? Thanks.

https://koji.fedoraproject.org/koji/buildinfo?buildID=1832655
https://koji.fedoraproject.org/koji/buildinfo?buildID=1832838

And maybe you could attach GDB to the stuck process and check what it is doing?

Comment 2 Mikhail 2021-09-17 06:58:15 UTC
Created attachment 1823725 [details]
steam backtrace

(In reply to Florian Weimer from comment #1)
> Could you test glibc-2.34.9000-7.fc36 and glibc-2.34-5.fc35 as well? Thanks.
> 
> https://koji.fedoraproject.org/koji/buildinfo?buildID=1832655
> https://koji.fedoraproject.org/koji/buildinfo?buildID=1832838
> 
> And maybe you could attach GDB to the stuck process and check what it is
> doing?

glibc-2.34.9000-5.fc36 - good (Steam is working)
glibc-2.34.9000-7.fc36 - bad (same as 2.34.9000-8.fc36)

Comment 3 Mikhail 2021-09-17 07:34:07 UTC
2.34-5.fc35 - also bad (same as 2.34.9000-8.fc36)

Comment 4 Mikhail 2021-09-17 07:34:46 UTC
Created attachment 1823729 [details]
yet another steam backtrace

Comment 5 Florian Weimer 2021-09-17 09:38:53 UTC
Hmm.  These backtraces are not really illuminating. I made a first guess what might be causing this, and have provided a test build here which effectively reverts one of the changes:

https://koji.fedoraproject.org/koji/taskinfo?taskID=75833350

Comment 6 Florian Weimer 2021-09-17 11:08:38 UTC
Created attachment 1823866 [details]
Test patch used for glibc-2.34.9000-8.fc36.bz2005142.0

Comment 7 Mikhail 2021-09-17 11:22:29 UTC
Just checked Steam client with glibc 2.34.9000-8.fc36.bz2005142.0 and can confirm that the issue was gone.
Thanks.

Comment 8 Florian Weimer 2021-09-17 12:43:21 UTC
(In reply to Mikhail from comment #7)
> Just checked Steam client with glibc 2.34.9000-8.fc36.bz2005142.0 and can
> confirm that the issue was gone.

Thank you!

Would you mind testing another build, please? https://koji.fedoraproject.org/koji/taskinfo?taskID=75839828

glibc-2.34.9000-8.fc36.bz2005142.1 contains the real upstream fix posted here:

nptl: pthread_kill needs to return ESRCH for old programs (bug 19193)
https://sourceware.org/pipermail/libc-alpha/2021-September/131150.html

Comment 9 Mikhail 2021-09-17 14:45:35 UTC
glibc 2.34.9000-8.fc36.bz2005142.1 looks good to me too
Thanks

Comment 10 Florian Weimer 2021-09-23 18:46:39 UTC
Fixed in rawhide. I believe I updated the pending Fedora 35 update in time with a fix, too, so this issue will never be present in Fedora 35.


Note You need to log in before you can comment on or make changes to this bug.